function [sol_RK4,avg_num_iter,avg_time_RK4,avg_oper] = baseline_tracker

% Purpose: to test algorithm for 100 random data sets and find the average
% time, number of operations, and number of iterations.

% Create a set of 100 random vectors for fixed patching methods as input
all_v = rand(100,9)*2-1;

time_rk4 = 0;
iterations = 0;
operations = 0;

for i = 1:size(all_v,1)
    
    v = all_v(i,:);
    
    % Profile and time code
    profile on
    t_start_rk4 = tic;
    [sol_RK4,iter_counter_RK4] = baseline_tracker_rk4(v);
    t_end_rk4 = toc(t_start_rk4);
    profileStruct = profile('info');
    [flopTotal,~]  = FLOPS('baseline_tracker_rk4','MATfilename',profileStruct);
    
    % Add data for time, number of operations, and number of steps
    time_rk4 = time_rk4 + t_end_rk4;
    iterations = iterations + iter_counter_RK4;
    operations = operations + flopTotal;
    
end

% Average over the number of runs completed to get desired data
avg_num_iter = iterations/size(all_v,1);
avg_time_RK4 = time_rk4/size(all_v,1);
avg_oper = operations/size(all_v,1);

return