function [M_star, M_hat] = pinv_setup

% Purpose: to read in data for target and start systems.  The start data is
% from Bertini, whereas the target data can come from Bertini (commented
% out below) or be random (as is currently set up for testing).

% Target data from Bertini
% final_parameters = fopen('final_parameters','r');
% fscanf(final_parameters,'%d',1);
% p_hat_data = fscanf(final_parameters,'%e');
% fclose(final_parameters);
% p_hat_values = vec2mat(p_hat_data,2);
% p_hat_complex = p_hat_values(:,1) + p_hat_values(:,2)*1i;
% p_hat = vec2mat(p_hat_complex,9);

% Setting up random endpoint target parameters between -1 and 1
p_hat = rand(5,9)*2 - 1;

% Read in info. from Bertini run - will include known system info.
parameters = fopen('start_parameters','r');
fscanf(parameters,'%d',1);
p_star_data = fscanf(parameters,'%e');
fclose(parameters);
p_star_values = vec2mat(p_star_data,2);
p_star_complex = p_star_values(:,1) + p_star_values(:,2)*1i;
p_star = vec2mat(p_star_complex,9);

% Development of data from parameters for homotopy equation setup
M_star = null(p_star);
M_hat = null(p_hat);

return