function [G, dGy, dGt] = pinv_evalhom_6pt(y,t,p_star,p_hat,v,Rand)

p = p_star*t + p_hat*(1-t);
%derivative of p with respect to t
dp = p_star - p_hat;
E = [y(1,1) y(2,1) y(3,1); ...
    y(4,1) y(5,1) y(6,1); ...
    y(7,1) y(8,1) y(9,1)];
lambda = y(10,1);

W1 = (p(2,1)*p(1,1))*E(1,1) + (p(2,2)*p(1,1))*E(1,2) + (p(2,1)*p(1,2))*E(2,1) + (p(2,2)*p(1,2))*E(2,2) + ...
    (p(1,1)*(lambda*(p(2,1)^2 + p(2,2)^2) + 1))*E(1,3) + (p(1,2)*(lambda*(p(2,1)^2 + p(2,2)^2) + 1))*E(2,3) + ...
    (p(2,1)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1))*E(3,1) + (p(2,2)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,1)^2 + p(2,2)^2) + 1)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1))*E(3,3);
W2 = (p(2,3)*p(1,3))*E(1,1) + (p(2,4)*p(1,3))*E(1,2) + (p(2,3)*p(1,4))*E(2,1) + (p(2,4)*p(1,4))*E(2,2) + ...
    (p(1,3)*(lambda*(p(2,3)^2 + p(2,4)^2) + 1))*E(1,3) + (p(1,4)*(lambda*(p(2,3)^2 + p(2,4)^2) + 1))*E(2,3) + ...
    (p(2,3)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1))*E(3,1) + (p(2,4)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,3)^2 + p(2,4)^2) + 1)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1))*E(3,3);
W3 = (p(2,5)*p(1,5))*E(1,1) + (p(2,6)*p(1,5))*E(1,2) + (p(2,5)*p(1,6))*E(2,1) + (p(2,6)*p(1,6))*E(2,2) + ...
    (p(1,5)*(lambda*(p(2,5)^2 + p(2,6)^2) + 1))*E(1,3) + (p(1,6)*(lambda*(p(2,5)^2 + p(2,6)^2) + 1))*E(2,3) + ...
    (p(2,5)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1))*E(3,1) + (p(2,6)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,5)^2 + p(2,6)^2) + 1)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1))*E(3,3);
W4 = (p(2,7)*p(1,7))*E(1,1) + (p(2,8)*p(1,7))*E(1,2) + (p(2,7)*p(1,8))*E(2,1) + (p(2,8)*p(1,8))*E(2,2) + ...
    (p(1,7)*(lambda*(p(2,7)^2 + p(2,8)^2) + 1))*E(1,3) + (p(1,8)*(lambda*(p(2,7)^2 + p(2,8)^2) + 1))*E(2,3) + ...
    (p(2,7)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1))*E(3,1) + (p(2,8)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,7)^2 + p(2,8)^2) + 1)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1))*E(3,3);
W5 = (p(2,9)*p(1,9))*E(1,1) + (p(2,10)*p(1,9))*E(1,2) + (p(2,9)*p(1,10))*E(2,1) + (p(2,10)*p(1,10))*E(2,2) + ...
    (p(1,9)*(lambda*(p(2,9)^2 + p(2,10)^2) + 1))*E(1,3) + (p(1,10)*(lambda*(p(2,9)^2 + p(2,10)^2) + 1))*E(2,3) + ...
    (p(2,9)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1))*E(3,1) + (p(2,10)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,9)^2 + p(2,10)^2) + 1)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1))*E(3,3);
W6 = (p(2,11)*p(1,11))*E(1,1) + (p(2,12)*p(1,11))*E(1,2) + (p(2,11)*p(1,12))*E(2,1) + (p(2,12)*p(1,12))*E(2,2) + ...
    (p(1,11)*(lambda*(p(2,11)^2 + p(2,12)^2) + 1))*E(1,3) + (p(1,12)*(lambda*(p(2,11)^2 + p(2,12)^2) + 1))*E(2,3) + ...
    (p(2,11)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1))*E(3,1) + (p(2,12)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1))*E(3,2) + ...
    ((lambda*(p(2,11)^2 + p(2,12)^2) + 1)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1))*E(3,3);

dW1y = [p(2,1)*p(1,1), p(2,2)*p(1,1), p(1,1)*(lambda*(p(2,1)^2 + p(2,2)^2) + 1), p(2,1)*p(1,2), p(2,2)*p(1,2), ...
    p(1,2)*(lambda*(p(2,1)^2 + p(2,2)^2) + 1), p(2,1)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1), ...
    p(2,2)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1), (lambda*(p(2,1)^2 + p(2,2)^2) + 1)*(lambda*(p(1,1)^2 + p(1,2)^2) + 1), ...
    (p(1,1)*E(1,3) + p(1,2)*E(2,3) + E(3,3))*(p(2,1)^2 + p(2,2)^2) + (p(2,1)*E(3,1) + p(2,2)*E(3,2) + E(3,3))*(p(1,1)^2 + p(1,2)^2) + ...
    2*lambda*(p(2,1)^2 + p(2,2)^2)*(p(1,1)^2 + p(1,2)^2)*E(3,3)];

dW2y = [p(2,3)*p(1,3), p(2,4)*p(1,3), p(1,3)*(lambda*(p(2,3)^2 + p(2,4)^2) + 1), p(2,3)*p(1,4), p(2,4)*p(1,4), ...
    p(1,4)*(lambda*(p(2,3)^2 + p(2,4)^2) + 1), p(2,3)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1), ...
    p(2,4)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1), (lambda*(p(2,3)^2 + p(2,4)^2) + 1)*(lambda*(p(1,3)^2 + p(1,4)^2) + 1), ...
    (p(1,3)*E(1,3) + p(1,4)*E(2,3) + E(3,3))*(p(2,3)^2 + p(2,4)^2) + (p(2,3)*E(3,1) + p(2,4)*E(3,2) + E(3,3))*(p(1,3)^2 + p(1,4)^2) + ...
    2*lambda*(p(2,3)^2 + p(2,4)^2)*(p(1,3)^2 + p(1,4)^2)*E(3,3)];

dW3y = [p(2,5)*p(1,5), p(2,6)*p(1,5), p(1,5)*(lambda*(p(2,5)^2 + p(2,6)^2) + 1), p(2,5)*p(1,6), p(2,6)*p(1,6), ...
    p(1,6)*(lambda*(p(2,5)^2 + p(2,6)^2) + 1), p(2,5)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1), ...
    p(2,6)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1), (lambda*(p(2,5)^2 + p(2,6)^2) + 1)*(lambda*(p(1,5)^2 + p(1,6)^2) + 1), ...
    (p(1,5)*E(1,3) + p(1,6)*E(2,3) + E(3,3))*(p(2,5)^2 + p(2,6)^2) + (p(2,5)*E(3,1) + p(2,6)*E(3,2) + E(3,3))*(p(1,5)^2 + p(1,6)^2) + ...
    2*lambda*(p(2,5)^2 + p(2,6)^2)*(p(1,5)^2 + p(1,6)^2)*E(3,3)];

dW4y = [p(2,7)*p(1,7), p(2,8)*p(1,7), p(1,7)*(lambda*(p(2,7)^2 + p(2,8)^2) + 1), p(2,7)*p(1,8), p(2,8)*p(1,8), ...
    p(1,8)*(lambda*(p(2,7)^2 + p(2,8)^2) + 1), p(2,7)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1), ...
    p(2,8)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1), (lambda*(p(2,7)^2 + p(2,8)^2) + 1)*(lambda*(p(1,7)^2 + p(1,8)^2) + 1), ...
    (p(1,7)*E(1,3) + p(1,8)*E(2,3) + E(3,3))*(p(2,7)^2 + p(2,8)^2) + (p(2,7)*E(3,1) + p(2,8)*E(3,2) + E(3,3))*(p(1,7)^2 + p(1,8)^2) + ...
    2*lambda*(p(2,7)^2 + p(2,8)^2)*(p(1,7)^2 + p(1,8)^2)*E(3,3)];
    
dW5y = [p(2,9)*p(1,9), p(2,10)*p(1,9), p(1,9)*(lambda*(p(2,9)^2 + p(2,10)^2) + 1), p(2,9)*p(1,10), p(2,10)*p(1,10), ...
    p(1,10)*(lambda*(p(2,9)^2 + p(2,10)^2) + 1), p(2,9)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1), ...
    p(2,10)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1), (lambda*(p(2,9)^2 + p(2,10)^2) + 1)*(lambda*(p(1,9)^2 + p(1,10)^2) + 1), ...
    (p(1,9)*E(1,3) + p(1,10)*E(2,3) + E(3,3))*(p(2,9)^2 + p(2,10)^2) + (p(2,9)*E(3,1) + p(2,10)*E(3,2) + E(3,3))*(p(1,9)^2 + p(1,10)^2) + ...
    2*lambda*(p(2,9)^2 + p(2,10)^2)*(p(1,9)^2 + p(1,10)^2)*E(3,3)];

dW6y = [p(2,11)*p(1,11), p(2,12)*p(1,11), p(1,11)*(lambda*(p(2,11)^2 + p(2,12)^2) + 1), p(2,11)*p(1,12), p(2,12)*p(1,12), ...
    p(1,12)*(lambda*(p(2,11)^2 + p(2,12)^2) + 1), p(2,11)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1), ...
    p(2,12)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1), (lambda*(p(2,11)^2 + p(2,12)^2) + 1)*(lambda*(p(1,11)^2 + p(1,12)^2) + 1), ...
    (p(1,11)*E(1,3) + p(1,12)*E(2,3) + E(3,3))*(p(2,11)^2 + p(2,12)^2) + (p(2,11)*E(3,1) + p(2,12)*E(3,2) + E(3,3))*(p(1,11)^2 + p(1,12)^2) + ...
    2*lambda*(p(2,11)^2 + p(2,12)^2)*(p(1,11)^2 + p(1,12)^2)*E(3,3)];

dW1t = (dp(2,1)*p(1,1) + p(2,1)*dp(1,1))*E(1,1) + (dp(2,2)*p(1,1) + p(2,2)*dp(1,1))*E(1,2) + ...
    (dp(2,1)*p(1,2) + p(2,1)*dp(1,2))*E(2,1) + (dp(2,2)*p(1,2) + p(2,2)*dp(1,2))*E(2,2) + ...
    (lambda*(p(1,1)*2*p(2,1)*dp(2,1) + dp(1,1)*p(2,1)^2 + p(1,1)*2*p(2,2)*dp(2,2) + dp(1,1)*p(2,2)^2) + dp(1,1))*E(1,3) + ...
    (lambda*(p(1,2)*2*p(2,1)*dp(2,1) + dp(1,2)*p(2,1)^2 + p(1,2)*2*p(2,2)*dp(2,2) + dp(1,2)*p(2,2)^2) + dp(1,2))*E(2,3) + ...
    (lambda*(p(2,1)*2*p(1,1)*dp(1,1) + dp(2,1)*p(1,1)^2 + p(2,1)*2*p(1,2)*dp(1,2) + dp(2,1)*p(1,2)^2) + dp(2,1))*E(3,1) + ...
    (lambda*(p(2,2)*2*p(1,1)*dp(1,1) + dp(2,2)*p(1,1)^2 + p(2,2)*2*p(1,2)*dp(1,2) + dp(2,2)*p(1,2)^2) + dp(2,2))*E(3,2) + ...
    (2*lambda^2*((p(2,1)^2 + p(2,2)^2)*(p(1,1)*dp(1,1)+p(1,2)*dp(1,2)) + (p(1,1)^2 + p(1,2)^2)*(p(2,1)*dp(2,1) + p(2,2)*dp(2,2))) + ...
    2*lambda*(p(2,1)*dp(2,1) + p(2,2)*dp(2,2) + p(1,1)*dp(1,1) + p(1,2)*dp(1,2)))*E(3,3);
dW2t = (dp(2,3)*p(1,3) + p(2,3)*dp(1,3))*E(1,1) + (dp(2,4)*p(1,3) + p(2,4)*dp(1,3))*E(1,2) + ...
    (dp(2,3)*p(1,4) + p(2,3)*dp(1,4))*E(2,1) + (dp(2,4)*p(1,4) + p(2,4)*dp(1,4))*E(2,2) + ...
    (lambda*(p(1,3)*2*p(2,3)*dp(2,3) + dp(1,3)*p(2,3)^2 + p(1,3)*2*p(2,4)*dp(2,4) + dp(1,3)*p(2,4)^2) + dp(1,3))*E(1,3) + ...
    (lambda*(p(1,4)*2*p(2,3)*dp(2,3) + dp(1,4)*p(2,3)^2 + p(1,4)*2*p(2,4)*dp(2,4) + dp(1,4)*p(2,4)^2) + dp(1,4))*E(2,3) + ...
    (lambda*(p(2,3)*2*p(1,3)*dp(1,3) + dp(2,3)*p(1,3)^2 + p(2,3)*2*p(1,4)*dp(1,4) + dp(2,3)*p(1,4)^2) + dp(2,3))*E(3,1) + ...
    (lambda*(p(2,4)*2*p(1,3)*dp(1,3) + dp(2,4)*p(1,3)^2 + p(2,4)*2*p(1,4)*dp(1,4) + dp(2,4)*p(1,4)^2) + dp(2,4))*E(3,2) + ...
    (2*lambda^2*((p(2,3)^2 + p(2,4)^2)*(p(1,3)*dp(1,3)+p(1,4)*dp(1,4)) + (p(1,3)^2 + p(1,4)^2)*(p(2,3)*dp(2,3) + p(2,4)*dp(2,4))) + ...
    2*lambda*(p(2,3)*dp(2,3) + p(2,4)*dp(2,4) + p(1,3)*dp(1,3) + p(1,4)*dp(1,4)))*E(3,3);
dW3t = (dp(2,5)*p(1,5) + p(2,5)*dp(1,5))*E(1,1) + (dp(2,6)*p(1,5) + p(2,6)*dp(1,5))*E(1,2) + ...
    (dp(2,5)*p(1,6) + p(2,5)*dp(1,6))*E(2,1) + (dp(2,6)*p(1,6) + p(2,6)*dp(1,6))*E(2,2) + ...
    (lambda*(p(1,5)*2*p(2,5)*dp(2,5) + dp(1,5)*p(2,5)^2 + p(1,5)*2*p(2,6)*dp(2,6) + dp(1,5)*p(2,6)^2) + dp(1,5))*E(1,3) + ...
    (lambda*(p(1,6)*2*p(2,5)*dp(2,5) + dp(1,6)*p(2,5)^2 + p(1,6)*2*p(2,6)*dp(2,6) + dp(1,6)*p(2,6)^2) + dp(1,6))*E(2,3) + ...
    (lambda*(p(2,5)*2*p(1,5)*dp(1,5) + dp(2,5)*p(1,5)^2 + p(2,5)*2*p(1,6)*dp(1,6) + dp(2,5)*p(1,6)^2) + dp(2,5))*E(3,1) + ...
    (lambda*(p(2,6)*2*p(1,5)*dp(1,5) + dp(2,6)*p(1,5)^2 + p(2,6)*2*p(1,6)*dp(1,6) + dp(2,6)*p(1,6)^2) + dp(2,6))*E(3,2) + ...
    (2*lambda^2*((p(2,5)^2 + p(2,6)^2)*(p(1,5)*dp(1,5)+p(1,6)*dp(1,6)) + (p(1,5)^2 + p(1,6)^2)*(p(2,5)*dp(2,5) + p(2,6)*dp(2,6))) + ...
    2*lambda*(p(2,5)*dp(2,5) + p(2,6)*dp(2,6) + p(1,5)*dp(1,5) + p(1,6)*dp(1,6)))*E(3,3);
dW4t = (dp(2,7)*p(1,7) + p(2,7)*dp(1,7))*E(1,1) + (dp(2,8)*p(1,7) + p(2,8)*dp(1,7))*E(1,2) + ...
    (dp(2,7)*p(1,8) + p(2,7)*dp(1,8))*E(2,1) + (dp(2,8)*p(1,8) + p(2,8)*dp(1,8))*E(2,2) + ...
    (lambda*(p(1,7)*2*p(2,7)*dp(2,7) + dp(1,7)*p(2,7)^2 + p(1,7)*2*p(2,8)*dp(2,8) + dp(1,7)*p(2,8)^2) + dp(1,7))*E(1,3) + ...
    (lambda*(p(1,8)*2*p(2,7)*dp(2,7) + dp(1,8)*p(2,7)^2 + p(1,8)*2*p(2,8)*dp(2,8) + dp(1,8)*p(2,8)^2) + dp(1,8))*E(2,3) + ...
    (lambda*(p(2,7)*2*p(1,7)*dp(1,7) + dp(2,7)*p(1,7)^2 + p(2,7)*2*p(1,8)*dp(1,8) + dp(2,7)*p(1,8)^2) + dp(2,7))*E(3,1) + ...
    (lambda*(p(2,8)*2*p(1,7)*dp(1,7) + dp(2,8)*p(1,7)^2 + p(2,8)*2*p(1,8)*dp(1,8) + dp(2,8)*p(1,8)^2) + dp(2,8))*E(3,2) + ...
    (2*lambda^2*((p(2,7)^2 + p(2,8)^2)*(p(1,7)*dp(1,7)+p(1,8)*dp(1,8)) + (p(1,7)^2 + p(1,8)^2)*(p(2,7)*dp(2,7) + p(2,8)*dp(2,8))) + ...
    2*lambda*(p(2,7)*dp(2,7) + p(2,8)*dp(2,8) + p(1,7)*dp(1,7) + p(1,8)*dp(1,8)))*E(3,3);
dW5t = (dp(2,9)*p(1,9) + p(2,9)*dp(1,9))*E(1,1) + (dp(2,10)*p(1,9) + p(2,10)*dp(1,9))*E(1,2) + ...
    (dp(2,9)*p(1,10) + p(2,9)*dp(1,10))*E(2,1) + (dp(2,10)*p(1,10) + p(2,10)*dp(1,10))*E(2,2) + ...
    (lambda*(p(1,9)*2*p(2,9)*dp(2,9) + dp(1,9)*p(2,9)^2 + p(1,9)*2*p(2,10)*dp(2,10) + dp(1,9)*p(2,10)^2) + dp(1,9))*E(1,3) + ...
    (lambda*(p(1,10)*2*p(2,9)*dp(2,9) + dp(1,10)*p(2,9)^2 + p(1,10)*2*p(2,10)*dp(2,10) + dp(1,10)*p(2,10)^2) + dp(1,10))*E(2,3) + ...
    (lambda*(p(2,9)*2*p(1,9)*dp(1,9) + dp(2,9)*p(1,9)^2 + p(2,9)*2*p(1,10)*dp(1,10) + dp(2,9)*p(1,10)^2) + dp(2,9))*E(3,1) + ...
    (lambda*(p(2,10)*2*p(1,9)*dp(1,9) + dp(2,10)*p(1,9)^2 + p(2,10)*2*p(1,10)*dp(1,10) + dp(2,10)*p(1,10)^2) + dp(2,10))*E(3,2) + ...
    (2*lambda^2*((p(2,9)^2 + p(2,10)^2)*(p(1,9)*dp(1,9)+p(1,10)*dp(1,10)) + (p(1,9)^2 + p(1,10)^2)*(p(2,9)*dp(2,9) + p(2,10)*dp(2,10))) + ...
    2*lambda*(p(2,9)*dp(2,9) + p(2,10)*dp(2,10) + p(1,9)*dp(1,9) + p(1,10)*dp(1,10)))*E(3,3);
dW6t = (dp(2,11)*p(1,11) + p(2,11)*dp(1,11))*E(1,1) + (dp(2,12)*p(1,11) + p(2,12)*dp(1,11))*E(1,2) + ...
    (dp(2,11)*p(1,12) + p(2,11)*dp(1,12))*E(2,1) + (dp(2,12)*p(1,12) + p(2,12)*dp(1,12))*E(2,2) + ...
    (lambda*(p(1,11)*2*p(2,11)*dp(2,11) + dp(1,11)*p(2,11)^2 + p(1,11)*2*p(2,12)*dp(2,12) + dp(1,11)*p(2,12)^2) + dp(1,11))*E(1,3) + ...
    (lambda*(p(1,12)*2*p(2,11)*dp(2,11) + dp(1,12)*p(2,11)^2 + p(1,12)*2*p(2,12)*dp(2,12) + dp(1,12)*p(2,12)^2) + dp(1,12))*E(2,3) + ...
    (lambda*(p(2,11)*2*p(1,11)*dp(1,11) + dp(2,11)*p(1,11)^2 + p(2,11)*2*p(1,12)*dp(1,12) + dp(2,11)*p(1,12)^2) + dp(2,11))*E(3,1) + ...
    (lambda*(p(2,12)*2*p(1,11)*dp(1,11) + dp(2,12)*p(1,11)^2 + p(2,12)*2*p(1,12)*dp(1,12) + dp(2,12)*p(1,12)^2) + dp(2,12))*E(3,2) + ...
    (2*lambda^2*((p(2,11)^2 + p(2,12)^2)*(p(1,11)*dp(1,11)+p(1,12)*dp(1,12)) + (p(1,11)^2 + p(1,12)^2)*(p(2,11)*dp(2,11) + p(2,12)*dp(2,12))) + ...
    2*lambda*(p(2,11)*dp(2,11) + p(2,12)*dp(2,12) + p(1,11)*dp(1,11) + p(1,12)*dp(1,12)))*E(3,3);

[F, dF_E] = evalfunc(E);

G = [Rand*F;W1;W2;W3;W4;W5;W6;v*y(1:9,1) - 1];

dGy = [Rand*dF_E, zeros(3,1);dW1y;dW2y;dW3y;dW4y;dW5y;dW6y;v, 0];

dGt = [zeros(3,1);dW1t;dW2t;dW3t;dW4t;dW5t;dW6t;zeros(1,1)];

return