function [F, dF_E] = evalfunc(E)

%Purpose: to have a general file to set up 9 equations of the homotopy
%function based on the fundamental matrix data, E, and find the derivative 
% based on E.

F = reshape(2*(E*E.')*E - trace(E*E.')*E,[9 1]);

dF_E = [[ 3*E(1,1)^2 + E(1,2)^2 + E(1,3)^2 + E(2,1)^2 - E(2,2)^2 - E(2,3)^2 + E(3,1)^2 - E(3,2)^2 - E(3,3)^2,                                          2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2),                                          2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3),                                          2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                                          2*E(1,2)*E(2,1) - 2*E(1,1)*E(2,2),                                                          2*E(1,3)*E(2,1) - 2*E(1,1)*E(2,3),                                          2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3),                                                          2*E(1,2)*E(3,1) - 2*E(1,1)*E(3,2),                                                          2*E(1,3)*E(3,1) - 2*E(1,1)*E(3,3)]
[                                          2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                                        2*E(1,1)*E(2,2) - 2*E(1,2)*E(2,1),                                                        2*E(1,1)*E(2,3) - 2*E(1,3)*E(2,1), E(1,1)^2 - E(1,2)^2 - E(1,3)^2 + 3*E(2,1)^2 + E(2,2)^2 + E(2,3)^2 + E(3,1)^2 - E(3,2)^2 - E(3,3)^2,                                            2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2),                                            2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3),                                          2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3),                                                          2*E(2,2)*E(3,1) - 2*E(2,1)*E(3,2),                                                          2*E(2,3)*E(3,1) - 2*E(2,1)*E(3,3)]
[                                          2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3),                                                        2*E(1,1)*E(3,2) - 2*E(1,2)*E(3,1),                                                        2*E(1,1)*E(3,3) - 2*E(1,3)*E(3,1),                                          2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3),                                                          2*E(2,1)*E(3,2) - 2*E(2,2)*E(3,1),                                                          2*E(2,1)*E(3,3) - 2*E(2,3)*E(3,1), E(1,1)^2 - E(1,2)^2 - E(1,3)^2 + E(2,1)^2 - E(2,2)^2 - E(2,3)^2 + 3*E(3,1)^2 + E(3,2)^2 + E(3,3)^2,                                            2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2),                                            2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3)]
[                                          2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2), E(1,1)^2 + 3*E(1,2)^2 + E(1,3)^2 - E(2,1)^2 + E(2,2)^2 - E(2,3)^2 - E(3,1)^2 + E(3,2)^2 - E(3,3)^2,                                          2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3),                                                        2*E(1,1)*E(2,2) - 2*E(1,2)*E(2,1),                                            2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                                          2*E(1,3)*E(2,2) - 2*E(1,2)*E(2,3),                                                        2*E(1,1)*E(3,2) - 2*E(1,2)*E(3,1),                                            2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3),                                                          2*E(1,3)*E(3,2) - 2*E(1,2)*E(3,3)]
[                                                        2*E(1,2)*E(2,1) - 2*E(1,1)*E(2,2),                                          2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                                        2*E(1,2)*E(2,3) - 2*E(1,3)*E(2,2),                                          2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2), - E(1,1)^2 + E(1,2)^2 - E(1,3)^2 + E(2,1)^2 + 3*E(2,2)^2 + E(2,3)^2 - E(3,1)^2 + E(3,2)^2 - E(3,3)^2,                                            2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3),                                                        2*E(2,1)*E(3,2) - 2*E(2,2)*E(3,1),                                            2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3),                                                          2*E(2,3)*E(3,2) - 2*E(2,2)*E(3,3)]
[                                                        2*E(1,2)*E(3,1) - 2*E(1,1)*E(3,2),                                          2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3),                                                        2*E(1,2)*E(3,3) - 2*E(1,3)*E(3,2),                                                        2*E(2,2)*E(3,1) - 2*E(2,1)*E(3,2),                                            2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3),                                                          2*E(2,2)*E(3,3) - 2*E(2,3)*E(3,2),                                          2*E(1,1)*E(1,2) + 2*E(2,1)*E(2,2) + 2*E(3,1)*E(3,2), - E(1,1)^2 + E(1,2)^2 - E(1,3)^2 - E(2,1)^2 + E(2,2)^2 - E(2,3)^2 + E(3,1)^2 + 3*E(3,2)^2 + E(3,3)^2,                                            2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3)]
[                                          2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3),                                          2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3), E(1,1)^2 + E(1,2)^2 + 3*E(1,3)^2 - E(2,1)^2 - E(2,2)^2 + E(2,3)^2 - E(3,1)^2 - E(3,2)^2 + E(3,3)^2,                                                        2*E(1,1)*E(2,3) - 2*E(1,3)*E(2,1),                                                          2*E(1,2)*E(2,3) - 2*E(1,3)*E(2,2),                                            2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                                        2*E(1,1)*E(3,3) - 2*E(1,3)*E(3,1),                                                          2*E(1,2)*E(3,3) - 2*E(1,3)*E(3,2),                                            2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3)]
[                                                        2*E(1,3)*E(2,1) - 2*E(1,1)*E(2,3),                                                        2*E(1,3)*E(2,2) - 2*E(1,2)*E(2,3),                                          2*E(1,1)*E(2,1) + 2*E(1,2)*E(2,2) + 2*E(1,3)*E(2,3),                                          2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3),                                            2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3), - E(1,1)^2 - E(1,2)^2 + E(1,3)^2 + E(2,1)^2 + E(2,2)^2 + 3*E(2,3)^2 - E(3,1)^2 - E(3,2)^2 + E(3,3)^2,                                                        2*E(2,1)*E(3,3) - 2*E(2,3)*E(3,1),                                                          2*E(2,2)*E(3,3) - 2*E(2,3)*E(3,2),                                            2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3)]
[                                                        2*E(1,3)*E(3,1) - 2*E(1,1)*E(3,3),                                                        2*E(1,3)*E(3,2) - 2*E(1,2)*E(3,3),                                          2*E(1,1)*E(3,1) + 2*E(1,2)*E(3,2) + 2*E(1,3)*E(3,3),                                                        2*E(2,3)*E(3,1) - 2*E(2,1)*E(3,3),                                                          2*E(2,3)*E(3,2) - 2*E(2,2)*E(3,3),                                            2*E(2,1)*E(3,1) + 2*E(2,2)*E(3,2) + 2*E(2,3)*E(3,3),                                          2*E(1,1)*E(1,3) + 2*E(2,1)*E(2,3) + 2*E(3,1)*E(3,3),                                            2*E(1,2)*E(1,3) + 2*E(2,2)*E(2,3) + 2*E(3,2)*E(3,3), - E(1,1)^2 - E(1,2)^2 + E(1,3)^2 - E(2,1)^2 - E(2,2)^2 + E(2,3)^2 + E(3,1)^2 + E(3,2)^2 + 3*E(3,3)^2]
 ];

return